# coding: utf-8

"""
    Pathnexus

    Pathnexus - a lab data harmonisation platform  # noqa: E501

    OpenAPI spec version: 4.6.0-SNAPSHOT
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from pathnexus_client.com.termlex.pathnexus.model.enumeration_address_type import EnumerationAddressType  # noqa: F401,E501
from pathnexus_client.com.termlex.pathnexus.model.enumeration_address_use import EnumerationAddressUse  # noqa: F401,E501
from pathnexus_client.com.termlex.pathnexus.model.extension import Extension  # noqa: F401,E501
from pathnexus_client.com.termlex.pathnexus.model.period import Period  # noqa: F401,E501
from pathnexus_client.com.termlex.pathnexus.model.string_type import StringType  # noqa: F401,E501


class Address(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'format_comments_pre': 'list[str]',
        'format_comments_post': 'list[str]',
        'id': 'str',
        'extension': 'list[Extension]',
        'disallow_extensions': 'bool',
        'use': 'str',
        'type': 'str',
        'text': 'str',
        'line': 'list[StringType]',
        'city': 'str',
        'district': 'str',
        'state': 'str',
        'postal_code': 'str',
        'country': 'str',
        'period': 'Period',
        'type_element': 'EnumerationAddressType',
        'city_element': 'StringType',
        'district_element': 'StringType',
        'state_element': 'StringType',
        'postal_code_element': 'StringType',
        'country_element': 'StringType',
        'text_element': 'StringType',
        'use_element': 'EnumerationAddressUse',
        'empty': 'bool',
        'extension_first_rep': 'Extension',
        'id_element': 'StringType',
        'id_base': 'str',
        'primitive': 'bool',
        'resource': 'bool',
        'boolean_primitive': 'bool',
        'date_time': 'bool'
    }

    attribute_map = {
        'format_comments_pre': 'formatCommentsPre',
        'format_comments_post': 'formatCommentsPost',
        'id': 'id',
        'extension': 'extension',
        'disallow_extensions': 'disallowExtensions',
        'use': 'use',
        'type': 'type',
        'text': 'text',
        'line': 'line',
        'city': 'city',
        'district': 'district',
        'state': 'state',
        'postal_code': 'postalCode',
        'country': 'country',
        'period': 'period',
        'type_element': 'typeElement',
        'city_element': 'cityElement',
        'district_element': 'districtElement',
        'state_element': 'stateElement',
        'postal_code_element': 'postalCodeElement',
        'country_element': 'countryElement',
        'text_element': 'textElement',
        'use_element': 'useElement',
        'empty': 'empty',
        'extension_first_rep': 'extensionFirstRep',
        'id_element': 'idElement',
        'id_base': 'idBase',
        'primitive': 'primitive',
        'resource': 'resource',
        'boolean_primitive': 'booleanPrimitive',
        'date_time': 'dateTime'
    }

    def __init__(self, format_comments_pre=None, format_comments_post=None, id=None, extension=None, disallow_extensions=None, use=None, type=None, text=None, line=None, city=None, district=None, state=None, postal_code=None, country=None, period=None, type_element=None, city_element=None, district_element=None, state_element=None, postal_code_element=None, country_element=None, text_element=None, use_element=None, empty=None, extension_first_rep=None, id_element=None, id_base=None, primitive=None, resource=None, boolean_primitive=None, date_time=None):  # noqa: E501
        """Address - a model defined in Swagger"""  # noqa: E501

        self._format_comments_pre = None
        self._format_comments_post = None
        self._id = None
        self._extension = None
        self._disallow_extensions = None
        self._use = None
        self._type = None
        self._text = None
        self._line = None
        self._city = None
        self._district = None
        self._state = None
        self._postal_code = None
        self._country = None
        self._period = None
        self._type_element = None
        self._city_element = None
        self._district_element = None
        self._state_element = None
        self._postal_code_element = None
        self._country_element = None
        self._text_element = None
        self._use_element = None
        self._empty = None
        self._extension_first_rep = None
        self._id_element = None
        self._id_base = None
        self._primitive = None
        self._resource = None
        self._boolean_primitive = None
        self._date_time = None
        self.discriminator = None

        if format_comments_pre is not None:
            self.format_comments_pre = format_comments_pre
        if format_comments_post is not None:
            self.format_comments_post = format_comments_post
        if id is not None:
            self.id = id
        if extension is not None:
            self.extension = extension
        if disallow_extensions is not None:
            self.disallow_extensions = disallow_extensions
        if use is not None:
            self.use = use
        if type is not None:
            self.type = type
        if text is not None:
            self.text = text
        if line is not None:
            self.line = line
        if city is not None:
            self.city = city
        if district is not None:
            self.district = district
        if state is not None:
            self.state = state
        if postal_code is not None:
            self.postal_code = postal_code
        if country is not None:
            self.country = country
        if period is not None:
            self.period = period
        if type_element is not None:
            self.type_element = type_element
        if city_element is not None:
            self.city_element = city_element
        if district_element is not None:
            self.district_element = district_element
        if state_element is not None:
            self.state_element = state_element
        if postal_code_element is not None:
            self.postal_code_element = postal_code_element
        if country_element is not None:
            self.country_element = country_element
        if text_element is not None:
            self.text_element = text_element
        if use_element is not None:
            self.use_element = use_element
        if empty is not None:
            self.empty = empty
        if extension_first_rep is not None:
            self.extension_first_rep = extension_first_rep
        if id_element is not None:
            self.id_element = id_element
        if id_base is not None:
            self.id_base = id_base
        if primitive is not None:
            self.primitive = primitive
        if resource is not None:
            self.resource = resource
        if boolean_primitive is not None:
            self.boolean_primitive = boolean_primitive
        if date_time is not None:
            self.date_time = date_time

    @property
    def format_comments_pre(self):
        """Gets the format_comments_pre of this Address.  # noqa: E501


        :return: The format_comments_pre of this Address.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_pre

    @format_comments_pre.setter
    def format_comments_pre(self, format_comments_pre):
        """Sets the format_comments_pre of this Address.


        :param format_comments_pre: The format_comments_pre of this Address.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_pre = format_comments_pre

    @property
    def format_comments_post(self):
        """Gets the format_comments_post of this Address.  # noqa: E501


        :return: The format_comments_post of this Address.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_post

    @format_comments_post.setter
    def format_comments_post(self, format_comments_post):
        """Sets the format_comments_post of this Address.


        :param format_comments_post: The format_comments_post of this Address.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_post = format_comments_post

    @property
    def id(self):
        """Gets the id of this Address.  # noqa: E501


        :return: The id of this Address.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Address.


        :param id: The id of this Address.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def extension(self):
        """Gets the extension of this Address.  # noqa: E501


        :return: The extension of this Address.  # noqa: E501
        :rtype: list[Extension]
        """
        return self._extension

    @extension.setter
    def extension(self, extension):
        """Sets the extension of this Address.


        :param extension: The extension of this Address.  # noqa: E501
        :type: list[Extension]
        """

        self._extension = extension

    @property
    def disallow_extensions(self):
        """Gets the disallow_extensions of this Address.  # noqa: E501


        :return: The disallow_extensions of this Address.  # noqa: E501
        :rtype: bool
        """
        return self._disallow_extensions

    @disallow_extensions.setter
    def disallow_extensions(self, disallow_extensions):
        """Sets the disallow_extensions of this Address.


        :param disallow_extensions: The disallow_extensions of this Address.  # noqa: E501
        :type: bool
        """

        self._disallow_extensions = disallow_extensions

    @property
    def use(self):
        """Gets the use of this Address.  # noqa: E501


        :return: The use of this Address.  # noqa: E501
        :rtype: str
        """
        return self._use

    @use.setter
    def use(self, use):
        """Sets the use of this Address.


        :param use: The use of this Address.  # noqa: E501
        :type: str
        """
        allowed_values = ["HOME", "WORK", "TEMP", "OLD", "BILLING", "NULL"]  # noqa: E501
        if use not in allowed_values:
            raise ValueError(
                "Invalid value for `use` ({0}), must be one of {1}"  # noqa: E501
                .format(use, allowed_values)
            )

        self._use = use

    @property
    def type(self):
        """Gets the type of this Address.  # noqa: E501


        :return: The type of this Address.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this Address.


        :param type: The type of this Address.  # noqa: E501
        :type: str
        """
        allowed_values = ["POSTAL", "PHYSICAL", "BOTH", "NULL"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def text(self):
        """Gets the text of this Address.  # noqa: E501


        :return: The text of this Address.  # noqa: E501
        :rtype: str
        """
        return self._text

    @text.setter
    def text(self, text):
        """Sets the text of this Address.


        :param text: The text of this Address.  # noqa: E501
        :type: str
        """

        self._text = text

    @property
    def line(self):
        """Gets the line of this Address.  # noqa: E501


        :return: The line of this Address.  # noqa: E501
        :rtype: list[StringType]
        """
        return self._line

    @line.setter
    def line(self, line):
        """Sets the line of this Address.


        :param line: The line of this Address.  # noqa: E501
        :type: list[StringType]
        """

        self._line = line

    @property
    def city(self):
        """Gets the city of this Address.  # noqa: E501


        :return: The city of this Address.  # noqa: E501
        :rtype: str
        """
        return self._city

    @city.setter
    def city(self, city):
        """Sets the city of this Address.


        :param city: The city of this Address.  # noqa: E501
        :type: str
        """

        self._city = city

    @property
    def district(self):
        """Gets the district of this Address.  # noqa: E501


        :return: The district of this Address.  # noqa: E501
        :rtype: str
        """
        return self._district

    @district.setter
    def district(self, district):
        """Sets the district of this Address.


        :param district: The district of this Address.  # noqa: E501
        :type: str
        """

        self._district = district

    @property
    def state(self):
        """Gets the state of this Address.  # noqa: E501


        :return: The state of this Address.  # noqa: E501
        :rtype: str
        """
        return self._state

    @state.setter
    def state(self, state):
        """Sets the state of this Address.


        :param state: The state of this Address.  # noqa: E501
        :type: str
        """

        self._state = state

    @property
    def postal_code(self):
        """Gets the postal_code of this Address.  # noqa: E501


        :return: The postal_code of this Address.  # noqa: E501
        :rtype: str
        """
        return self._postal_code

    @postal_code.setter
    def postal_code(self, postal_code):
        """Sets the postal_code of this Address.


        :param postal_code: The postal_code of this Address.  # noqa: E501
        :type: str
        """

        self._postal_code = postal_code

    @property
    def country(self):
        """Gets the country of this Address.  # noqa: E501


        :return: The country of this Address.  # noqa: E501
        :rtype: str
        """
        return self._country

    @country.setter
    def country(self, country):
        """Sets the country of this Address.


        :param country: The country of this Address.  # noqa: E501
        :type: str
        """

        self._country = country

    @property
    def period(self):
        """Gets the period of this Address.  # noqa: E501


        :return: The period of this Address.  # noqa: E501
        :rtype: Period
        """
        return self._period

    @period.setter
    def period(self, period):
        """Sets the period of this Address.


        :param period: The period of this Address.  # noqa: E501
        :type: Period
        """

        self._period = period

    @property
    def type_element(self):
        """Gets the type_element of this Address.  # noqa: E501


        :return: The type_element of this Address.  # noqa: E501
        :rtype: EnumerationAddressType
        """
        return self._type_element

    @type_element.setter
    def type_element(self, type_element):
        """Sets the type_element of this Address.


        :param type_element: The type_element of this Address.  # noqa: E501
        :type: EnumerationAddressType
        """

        self._type_element = type_element

    @property
    def city_element(self):
        """Gets the city_element of this Address.  # noqa: E501


        :return: The city_element of this Address.  # noqa: E501
        :rtype: StringType
        """
        return self._city_element

    @city_element.setter
    def city_element(self, city_element):
        """Sets the city_element of this Address.


        :param city_element: The city_element of this Address.  # noqa: E501
        :type: StringType
        """

        self._city_element = city_element

    @property
    def district_element(self):
        """Gets the district_element of this Address.  # noqa: E501


        :return: The district_element of this Address.  # noqa: E501
        :rtype: StringType
        """
        return self._district_element

    @district_element.setter
    def district_element(self, district_element):
        """Sets the district_element of this Address.


        :param district_element: The district_element of this Address.  # noqa: E501
        :type: StringType
        """

        self._district_element = district_element

    @property
    def state_element(self):
        """Gets the state_element of this Address.  # noqa: E501


        :return: The state_element of this Address.  # noqa: E501
        :rtype: StringType
        """
        return self._state_element

    @state_element.setter
    def state_element(self, state_element):
        """Sets the state_element of this Address.


        :param state_element: The state_element of this Address.  # noqa: E501
        :type: StringType
        """

        self._state_element = state_element

    @property
    def postal_code_element(self):
        """Gets the postal_code_element of this Address.  # noqa: E501


        :return: The postal_code_element of this Address.  # noqa: E501
        :rtype: StringType
        """
        return self._postal_code_element

    @postal_code_element.setter
    def postal_code_element(self, postal_code_element):
        """Sets the postal_code_element of this Address.


        :param postal_code_element: The postal_code_element of this Address.  # noqa: E501
        :type: StringType
        """

        self._postal_code_element = postal_code_element

    @property
    def country_element(self):
        """Gets the country_element of this Address.  # noqa: E501


        :return: The country_element of this Address.  # noqa: E501
        :rtype: StringType
        """
        return self._country_element

    @country_element.setter
    def country_element(self, country_element):
        """Sets the country_element of this Address.


        :param country_element: The country_element of this Address.  # noqa: E501
        :type: StringType
        """

        self._country_element = country_element

    @property
    def text_element(self):
        """Gets the text_element of this Address.  # noqa: E501


        :return: The text_element of this Address.  # noqa: E501
        :rtype: StringType
        """
        return self._text_element

    @text_element.setter
    def text_element(self, text_element):
        """Sets the text_element of this Address.


        :param text_element: The text_element of this Address.  # noqa: E501
        :type: StringType
        """

        self._text_element = text_element

    @property
    def use_element(self):
        """Gets the use_element of this Address.  # noqa: E501


        :return: The use_element of this Address.  # noqa: E501
        :rtype: EnumerationAddressUse
        """
        return self._use_element

    @use_element.setter
    def use_element(self, use_element):
        """Sets the use_element of this Address.


        :param use_element: The use_element of this Address.  # noqa: E501
        :type: EnumerationAddressUse
        """

        self._use_element = use_element

    @property
    def empty(self):
        """Gets the empty of this Address.  # noqa: E501


        :return: The empty of this Address.  # noqa: E501
        :rtype: bool
        """
        return self._empty

    @empty.setter
    def empty(self, empty):
        """Sets the empty of this Address.


        :param empty: The empty of this Address.  # noqa: E501
        :type: bool
        """

        self._empty = empty

    @property
    def extension_first_rep(self):
        """Gets the extension_first_rep of this Address.  # noqa: E501


        :return: The extension_first_rep of this Address.  # noqa: E501
        :rtype: Extension
        """
        return self._extension_first_rep

    @extension_first_rep.setter
    def extension_first_rep(self, extension_first_rep):
        """Sets the extension_first_rep of this Address.


        :param extension_first_rep: The extension_first_rep of this Address.  # noqa: E501
        :type: Extension
        """

        self._extension_first_rep = extension_first_rep

    @property
    def id_element(self):
        """Gets the id_element of this Address.  # noqa: E501


        :return: The id_element of this Address.  # noqa: E501
        :rtype: StringType
        """
        return self._id_element

    @id_element.setter
    def id_element(self, id_element):
        """Sets the id_element of this Address.


        :param id_element: The id_element of this Address.  # noqa: E501
        :type: StringType
        """

        self._id_element = id_element

    @property
    def id_base(self):
        """Gets the id_base of this Address.  # noqa: E501


        :return: The id_base of this Address.  # noqa: E501
        :rtype: str
        """
        return self._id_base

    @id_base.setter
    def id_base(self, id_base):
        """Sets the id_base of this Address.


        :param id_base: The id_base of this Address.  # noqa: E501
        :type: str
        """

        self._id_base = id_base

    @property
    def primitive(self):
        """Gets the primitive of this Address.  # noqa: E501


        :return: The primitive of this Address.  # noqa: E501
        :rtype: bool
        """
        return self._primitive

    @primitive.setter
    def primitive(self, primitive):
        """Sets the primitive of this Address.


        :param primitive: The primitive of this Address.  # noqa: E501
        :type: bool
        """

        self._primitive = primitive

    @property
    def resource(self):
        """Gets the resource of this Address.  # noqa: E501


        :return: The resource of this Address.  # noqa: E501
        :rtype: bool
        """
        return self._resource

    @resource.setter
    def resource(self, resource):
        """Sets the resource of this Address.


        :param resource: The resource of this Address.  # noqa: E501
        :type: bool
        """

        self._resource = resource

    @property
    def boolean_primitive(self):
        """Gets the boolean_primitive of this Address.  # noqa: E501


        :return: The boolean_primitive of this Address.  # noqa: E501
        :rtype: bool
        """
        return self._boolean_primitive

    @boolean_primitive.setter
    def boolean_primitive(self, boolean_primitive):
        """Sets the boolean_primitive of this Address.


        :param boolean_primitive: The boolean_primitive of this Address.  # noqa: E501
        :type: bool
        """

        self._boolean_primitive = boolean_primitive

    @property
    def date_time(self):
        """Gets the date_time of this Address.  # noqa: E501


        :return: The date_time of this Address.  # noqa: E501
        :rtype: bool
        """
        return self._date_time

    @date_time.setter
    def date_time(self, date_time):
        """Sets the date_time of this Address.


        :param date_time: The date_time of this Address.  # noqa: E501
        :type: bool
        """

        self._date_time = date_time

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Address):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
